#encoding: utf-8

TMP_PATH = tmp_path
#压缩子目录
def add_file_to_zip(file_path, zip)  
    if File.directory?(file_path)  
      Dir.foreach(file_path) do |sub_file_name|  
        add_file_to_zip("#{file_path}/#{sub_file_name}", zip) unless sub_file_name == '.' or sub_file_name == '..'  
      end  
    else  
      zip.add(file_path, file_path)  
    end  
end  

#
def mkepub(filename,bookname,author,key1,key2,fencode,&block)
  txtfile = filename
  bookname.encode!("utf-8")
  author.encode!("utf-8")
  key1.encode!("utf-8")
  key2.encode!("utf-8")
  #拷贝文件至临时目录
  FileUtils.cp(txtfile,TMP_PATH + File::SEPARATOR + "i.txt")
  FileUtils.cp_r(RUNPATH + File::SEPARATOR + "epub",TMP_PATH)
  cur_dir = Dir::pwd
  Dir.chdir(TMP_PATH)

  #toc.ncx
  toc = REXML::Document.new("<?xml version=\"1.0\" encoding=\"UTF-8\"?>")
  toc_tag = toc.add_element "ncx", {"version" => "2005-1","xmlns" => "http://www.daisy.org/z3986/2005/ncx/"} 
  head_tag = toc_tag.add_element "head"
    head_tag.add_element "meta",{"name" =>"dtb:uid"}
    head_tag.add_element "meta",{"name" =>"dtb:depth","content"=>"1"}
    head_tag.add_element "meta",{"name" =>"dtb:totalPageCount","content"=>"0"}
    head_tag.add_element "meta",{"name" =>"dtb:maxPageNumber","content"=>"0"}

  doctitle_tag = toc_tag.add_element "docTitle"
    txt_tag = doctitle_tag.add_element "text"
     txt_tag.text = bookname
    
  navmap_tag = toc_tag.add_element "navMap"
    navpoint_tag = navmap_tag.add_element "navPoint",{"id"=>"navPoint-1","playOrder"=>"1"}
    navpoint_tag.add_element("navLabel").add_element("text").text = "Title Page"
    navpoint_tag.add_element "content" ,{"src"=>"title_page.xhtml"}

  #title_page.xhtml
  title_page = REXML::Document.new("<?xml version=\"1.0\" encoding=\"UTF-8\"?>
  <!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">")
    html_tag = title_page.add_element "html",{ "xmlns" => "http://www.w3.org/1999/xhtml"}
      head_tag = html_tag.add_element("head")
        head_tag.add_element("title").text = bookname
        head_tag.add_element "link", {"href"=>"stylesheet.css", "type"=>"text/css", "rel"=>"stylesheet"}
      body_tag = html_tag.add_element("body")
        body_tag.add_element("h1").text = bookname
        body_tag.add_element("h2").text = author
  title_file = File.open("epub/title_page.xhtml",'w')
  title_file.write(title_page.to_s)
  title_file.close

  #content.opf
  content_page = REXML::Document.new("<?xml version=\"1.0\" encoding=\"UTF-8\"?>")
  package_tag = content_page.add_element "package",{"version"=>"2.0","xmlns"=>"http://www.idpf.org/2007/opf","unique-identifier"=>"BookId"}
    metadata_tag = package_tag.add_element "metadata",{"xmlns:dc"=>"http://purl.org/dc/elements/1.1/", "xmlns:opf"=>"http://www.idpf.org/2007/opf"}
      metadata_tag.add_element("dc:title").text = bookname
      metadata_tag.add_element("dc:language").text = "zh_CN"
      metadata_tag.add_element("dc:identifier",{"id"=>"BookId"}).text = ""
      metadata_tag.add_element("dc:creator",{"opf:role"=>"aut"}).text = author
      metadata_tag.add_element "dc:date"
    manifest_tag = package_tag.add_element "manifest"
      manifest_tag.add_element "item",{ "id"=>"ncx","href"=>"toc.ncx","media-type"=>"application/x-dtbncx+xml" }
      manifest_tag.add_element "item",{ "id"=>"style","href"=>"stylesheet.css","media-type"=>"text/css"}
      manifest_tag.add_element "item",{ "id"=>"title_page", "href"=>"title_page.xhtml", "media-type"=>"application/xhtml+xml"}
    spine_tag =  package_tag.add_element "spine",{"toc"=>"ncx"}
      spine_tag.add_element "itemref",{ "idref"=>"title_page"}

    i = 1 #mulu
    ch_file = nil
    ch_page = nil
    row_count = File.stat("i.txt").size
    cur_count = 0
    wf = File.open("i.txt","r")
    if  fencode == "utf-8"
      wf.set_encoding('utf-8')
    end
    wf.each_line do |line|
      cur_count += line.bytesize
=begin      
      if is_win32
        line.encode!("utf-8") if fencode == "GBK"
      else
        line.encode!("utf-8","GBK") if fencode == "GBK"
      end
=end
      if fencode == "GBK"
        begin
          line.encode!("utf-8","GBK")
        rescue
          line ="    编码错误，此段略..."
        end
      end      
      w1 = line.index(key1)
      w2 = line.index(key2)
      nextch = false #next paragraph
      if w1 && w2 && w2-w1 >0 && w2-w1 <= 12 && line.bytesize <100
        if ch_file
          if ch_page.to_s.bytesize > 450
            ch_file.write(ch_page.to_s)
            ch_file.close
            nextch = false
            gb_line = "完成进度的 #{cur_count.to_f/row_count.to_f*100} %"
            gb_line.encode!("GBK") if is_win32
            puts gb_line
            if block
              block.call(cur_count.to_f/row_count.to_f)
            end

          else
            nextch =true
          end
        end

        if !nextch
          #write toc content
          navpoint_tag = navmap_tag.add_element "navPoint",{"id"=>"navPoint-#{i+1}","playOrder"=>"#{i+1}"}
          navpoint_tag.add_element("navLabel").add_element("text").text = line
          navpoint_tag.add_element "content" ,{"src"=>"ch#{i}.xhtml"}

          manifest_tag.add_element "item", {"id"=>"ch#{i}", "href"=>"ch#{i}.xhtml","media-type"=>"application/xhtml+xml" }
          spine_tag.add_element "itemref",{"idref"=>"ch#{i}"}

          ch_file = File.open("epub/ch#{i}.xhtml",'w')
          ch_page = REXML::Document.new("<?xml version=\"1.0\" encoding=\"UTF-8\"?>
          <!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">")
          html_tag = ch_page.add_element "html",{"xmlns"=>"http://www.w3.org/1999/xhtml"}
          head_tag = html_tag.add_element "head"
          head_tag.add_element("title").text = line
          head_tag.add_element "link",{ "href"=>"stylesheet.css", "type"=>"text/css", "rel"=>"stylesheet" }
          body_tag = html_tag.add_element "body"
          body_tag.add_element("h1").text = line
          i += 1
        else
          nextch = false
          
          navpoint_tag.elements[1].delete navpoint_tag.elements[1].elements[1]
          navpoint_tag.elements[1].add_element("text").text = line

          head_tag.delete head_tag.elements[1]
          head_tag.add_element("title").text = line

          new_h1 = REXML::Element.new('p')
          new_h1.text = body_tag.elements[1].text
          body_tag.replace_child body_tag.elements[1],new_h1
          body_tag.add_element("h1").text = line
        end
      else
        body_tag.add_element("p").text = line
      end
    end
    wf.close
  if ch_file
    ch_file.write(ch_page.to_s)
    ch_file.close
    gb_line = "完成进度的 #{cur_count.to_f/row_count.to_f*100} %"
    gb_line.encode!("GBK") if is_win32
    puts gb_line
    if block
      block.call(cur_count.to_f/row_count.to_f)
    end
  end

  toc_file = File.open("epub/toc.ncx",'w')
  toc_s = toc.to_s
  toc_file.write(toc_s)
  toc_file.close

  title_file = File.open("epub/title_page.xhtml",'w')
  title_file.set_encoding('utf-8')
  title_file.write(title_page.to_s)
  title_file.close

  content_file = File.open("epub/content.opf",'w')
  content_file.set_encoding('utf-8')
  content_file.write(content_page.to_s)
  content_file.close

  Dir.chdir("epub")
  epubfile = Zip::ZipFile.open(".." + File::SEPARATOR + "out.epub", Zip::ZipFile::CREATE)
  add_file_to_zip(".",epubfile)
  epubfile.close
  Dir.chdir(cur_dir)
  FileUtils.cp(TMP_PATH + File::SEPARATOR + "out.epub",File.dirname(txtfile) + File::SEPARATOR + bookname +".epub")
  FileUtils.rm(TMP_PATH + File::SEPARATOR + "out.epub")
  FileUtils.rm(TMP_PATH + File::SEPARATOR + "i.txt")
  FileUtils.rm_r(TMP_PATH + File::SEPARATOR + "epub")

end