#!/usr/bin/env ruby
#encoding: utf-8
#epub制作工具

#查找当前程序运行路径
RUNPATH = File.dirname(__FILE__)

$: << RUNPATH
require 'gtk2'
require "rexml/document"
require "fileutils" 
require 'zip/zipfilesystem'

#加载自定义模块
load "class_extend.rb" #类扩展和工具函数
load "mkepub.rb" #类扩展和工具函数

class Builder < Gtk::Builder

  def initialize xml
    super()
    self.add_from_file(xml)
    self['dialog1'].set_window_position Gtk::Window::POS_CENTER
    self['dialog1'].set_default_size(400, 300)
    self['dialog1'].signal_connect('destroy') { Gtk::main_quit }
    self['dialog1'].show_all
    @bookname = self['entry1']
    @author = self['entry2']
    @key1 =  self['entry3']
    @key2 =  self['entry4']
    @fchooser = self['filechooserbutton1']
    @progresswin = self["progress_win"]
    @progress = self["progressbar1"]
    @ok_btn = self["button1"]
    @encode_btn = self["radiobutton1"]
    @timer = nil
    @work = false #loog time work

    ##运行的外部进程
    @check = nil
    self.connect_signals{ |handler| method(handler) }
  end

  def on_quit_clicked(widget)
     Gtk::main_quit()
  end

  #生成epub
  def on_ok_btn_clicked(widget)
    if @bookname.text == "" || @author.text == "" || @key1.text == "" || @key2.text == ""
      msgbox("输入错误\n请重新输入!")
    else
      @progresswin.show_all
      @progress.fraction= 0
      @timer = Gtk.timeout_add(1000){progress_timeout}
      thread1 =  Thread.start do
        @ok_btn.sensitive = false
        filename =  @fchooser.filename
        bookname = @bookname.text
        author = @author.text
        key1 = @key1.text
        key2 = @key2.text
        fencode ="utf-8"
        fencode ="GBK" unless  @encode_btn.active?
        mkepub(filename,bookname,author,key1,key2,fencode){|pss| @progress.fraction = pss}
        @work = true
      end 
    end
  end

  private

  def progress_timeout
    if @work
      @ok_btn.sensitive = true
      @progresswin.hide_all
      Gtk::timeout_remove(@timer)
      @work = false
      return false
    else
      return true
    end
  end

  def msgbox(msg)
    mdialog = Gtk::MessageDialog.new(@window1, 
      Gtk::Dialog::DESTROY_WITH_PARENT,
      Gtk::MessageDialog::INFO,
      Gtk::MessageDialog::BUTTONS_CLOSE,
    msg)
    mdialog.run
    mdialog.destroy
  end
end
#主程序开始
PROG_PATH = RUNPATH + File::SEPARATOR + "toepub.glade"
Gtk.init
builder = Builder.new(PROG_PATH)
Gtk.main

